#ifndef LINT
static char *rcsid="$Id: breakzmsg.c 239 2004-12-14 21:45:01Z crosser $";
#endif

/*
	$Log: breakzmsg.c,v $
	Revision 1.14  2003/09/14 21:16:18  crosser
	I hardly beleive it but the new varpool thing seems to work!
	
	Revision 1.13  2003/09/11 12:43:34  crosser
	cosmetic
	
	Revision 1.12  2003/09/11 07:22:08  crosser
	cleanup unneeded stat.h
	
	Revision 1.11  2003/09/08 12:55:55  crosser
	make static and dynamic plugins syntactically identical
	
	Revision 1.10  2003/09/04 18:03:41  crosser
	changed (and broke) scanning for attributes in the headers
	
	Revision 1.9  2003/09/03 18:32:50  crosser
	work in progress on new calling conventions
	
	Revision 1.8  2003/09/02 09:59:34  crosser
	fix missing/extra headers and off by one errors
	
	Revision 1.7  2003/09/01 22:39:00  crosser
	scan interesting headers
	FIXME: skip processing of last header
	
	Revision 1.6  2003/09/01 18:20:45  crosser
	proper test format
	debugging readconfig error - int var
	
	Revision 1.5  2003/09/01 09:39:21  crosser
	add head comments where necessary
	add run time config function
	
	Revision 1.4  2003/09/01 08:42:01  crosser
	make termination func work
	
	Revision 1.3  2003/09/01 08:04:57  crosser
	fix alloca vs malloc
	
	Revision 1.2  2003/09/01 06:03:31  crosser
	implement code for "breakzmsg" filter (but working yet)
	
	Revision 1.1  2003/08/31 21:18:37  crosser
	made plugin framework
	
*/
                                                                                
/*
	WHAT IS IT:
		modularized contentfilter for Zmailer
	COPYRIGHT:
		(c) 2003 Eugene G. Crosser <crosser@average.org>
	LICENSE:
		The same set as apply to Zmailer code
*/

#include "config.h"

#include <sys/types.h>
#ifdef STDC_HEADERS
# include <stdio.h>
# include <string.h>
#endif

#include "report.h"
#include "zmscanner.h"

static int
breakzmsg_setup(void **cfgp)
{
	DPRINT(("breakzmsg_setup called\n"));
	(*cfgp)=NULL;
	return 0;
}

static void
breakzmsg_term(void **cfgp)
{
	DPRINT(("breakzmsg_term called\n"));
}

static int
breakzmsg_scan(char *stage,int depth,slab_t data,varpool_t vp,void *priv)
{
	int rc;
	char *p,*q,*ls;
	slab_t edata;
	static char *pat="\nenv-end\n";

	DPRINT(("breakzmsg_scan called size=%d\n",slab_size(data)));
	memset(&edata,0,sizeof(edata));
	ls=data.beg;
	q=pat;
	for (p=data.beg;p<data.end;p++) {
		if (*p == '\r') continue;
		if (*q == '\0') break;
		if ((*p == '\n') && (q == pat)) {
			DPRINT(("env line at offset %d(%d): \"%.*s\"\n",
				ls-data.beg,p-ls,p-ls,ls));
			edata.beg=ls;
			edata.end=p;
			rc=scandata("zenvhdr",depth,edata,vp);
			if (rc != ZMSCAN_CONTINUE) return rc;
			ls=p+1;
		}
		if (*p == *q) {
			q++;
		} else if (*p == '\n') {
			q=pat+1;
		} else q=pat;
	}
	if (*q == '\0') {
		edata.beg=p;
		edata.end=data.end;
		DPRINT(("start rfc822 at off %d: \"%.20s\"\n",
					edata.beg-data.beg,edata.beg));
		return scandata("rfc822",depth,edata,vp);
	} else {
		ERRLOG((LOG_WARNING,"\"env-end\" not found in a message"));
		/* try the thing as RFC-822 message */
		return scandata("rfc822",depth,data,vp);
	}
}

ZMS_MODULE("zmsg","breakzmsg",breakzmsg_setup,breakzmsg_term,breakzmsg_scan);
